package controllers;

import items.Item;

import java.awt.event.KeyEvent;

import lists.ItemList;
import lists.ListItem;
import models.GameModel;
import models.InventoryModel;
import ui.Jorma;
import chars.Player;

public class InventoryController extends Controller {

    public InventoryController(InventoryModel model) {
	super(model);
    }

    public void keyPressed(KeyEvent e) {
	InventoryModel m = (InventoryModel) model;
	ItemList itemList = m.getItemList();
	int action = m.getAction();
	Player player = m.getPlayer();

	switch (e.getKeyCode()) {
	case KeyEvent.VK_ESCAPE:
	    m.getWindow().getJorma().setCurrentModel(Jorma.MODEL_GAME);
	    break;
	case KeyEvent.VK_1:
	    m.setAction(InventoryModel.ACTION_USE);
	    break;
	case KeyEvent.VK_2:
	    m.setAction(InventoryModel.ACTION_WIELD);
	    break;
	case KeyEvent.VK_3:
	    m.setAction(InventoryModel.ACTION_DROP);
	    break;
	case KeyEvent.VK_UP:
	    itemList.prevPage();
	    break;
	case KeyEvent.VK_DOWN:
	    itemList.nextPage();
	    break;
	default:
	    for (ListItem l : itemList.getCurrentPage().getListItems()) {
		if (l.getLetter() == e.getKeyChar()) {
		    Item i = l.getItem();
		    switch (action) {
		    case InventoryModel.ACTION_USE:
			String useMessage = i.use();
			if (!useMessage.equals("")) {
			    m.getWindow().getJorma()
				    .setCurrentModel(Jorma.MODEL_GAME);
			    ((GameModel) Jorma.MODEL_GAME)
				    .addMessage(useMessage);
			}
			break;
		    case InventoryModel.ACTION_WIELD:
			i.wield();
			itemList.update(player.getItems());
			break;
		    case InventoryModel.ACTION_DROP:
			i.drop();
			itemList.update(player.getItems());
			break;
		    }
		    break;
		}
	    }
	}
    }
}
