package game;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Timer;
import java.util.TimerTask;

import models.GameModel;

import ui.Jorma;
import chars.Player;

public class Listener implements KeyListener {

    private Jorma jorma;
    private Timer keyDownTimer;
    private KeyEvent keyDownEvent;

    public Listener(Jorma jorma) {
	this.jorma = jorma;
	this.keyDownTimer = new Timer();
    }

    @Override
    public void keyPressed(KeyEvent event) {
	keyDownTimer.cancel();
	keyDownEvent = event;
	keyDownTimer = new Timer();
	keyDownTimer.schedule(new KeyDownTask(), 500, 50);
	jorma.getCurrentModel().getController().keyPressed(event);
    }

    @Override
    public void keyReleased(KeyEvent event) {
	stopQuickEvents();
    }

    @Override
    public void keyTyped(KeyEvent event) {
    }

    public class KeyDownTask extends TimerTask {

	public void run() {
	    Player player;
	    if (jorma.getCurrentModel() == Jorma.MODEL_GAME) {
		player = (Player) ((GameModel) jorma.getCurrentModel())
			.getPlayer();
		if (player.getHp() < player.getMaxHp() * 0.3) {
		    stopQuickEvents();
		    return;
		}
	    }
	    if (keyDownEvent != null)
		jorma.getCurrentModel().getController().keyPressed(keyDownEvent);
	}
    }

    private void stopQuickEvents() {
	keyDownTimer.cancel();
	keyDownEvent = null;
    }
}
