package items;

import java.util.ArrayList;

public class OwnerType {

    private static ArrayList<OwnerType> types = new ArrayList<OwnerType>();

    public static final OwnerType VILLAGER = new OwnerType("villager");
    public static final OwnerType FIGHTER = new OwnerType("fighter");
    public static final OwnerType MAGICIAN = new OwnerType("magician");
    public static final OwnerType ANIMAL = new OwnerType("animal");
    public static final OwnerType AQUATIC = new OwnerType("aquatic");
    public static final OwnerType DRAGON = new OwnerType("dragon");

    private String name;
    private ArrayList<ItemPrototype> items;

    private OwnerType(String name) {
	this.name = name;
	items = new ArrayList<ItemPrototype>();
	types.add(this);
    }

    public void init() {
	types = new ArrayList<OwnerType>();
    }

    public static OwnerType stringToOwnerType(String name) {
	for (OwnerType it : types) {
	    if (it.getName().equals(name)) {
		return it;
	    }
	}

	return null;
    }

    public String getName() {
	return name;
    }

    public ArrayList<ItemPrototype> getItems() {
	return items;
    }
}
