package items;

import java.util.ArrayList;

import util.Util;

public class WieldSpot {

    private static ArrayList<WieldSpot> wieldSpots = new ArrayList<WieldSpot>();

    public static final WieldSpot WIELD_NONE = new WieldSpot(0, "none");
    public static final WieldSpot WIELD_HEAD = new WieldSpot(1, "head");
    public static final WieldSpot WIELD_CHEST = new WieldSpot(2, "chest");
    public static final WieldSpot WIELD_LEGS = new WieldSpot(3, "legs");
    public static final WieldSpot WIELD_FEET = new WieldSpot(6, "feet");
    public static final WieldSpot WIELD_RIGHTHAND = new WieldSpot(4,
	    "right hand");
    public static final WieldSpot WIELD_LEFTHAND = new WieldSpot(5, "left hand");
    public static final WieldSpot WIELD_FINGER = new WieldSpot(7, "finger");

    int type;
    String name;
    Item wieldedItem;

    private WieldSpot(int type, String name) {
	this.type = type;
	this.name = name;
	wieldSpots.add(this);
    }

    public static ArrayList<WieldSpot> getWieldSpots() {
	return wieldSpots;
    }

    public int getType() {
	return type;
    }

    public String getName() {
	return name;
    }

    public Item getWieldedItem() {
	return wieldedItem;
    }

    public void setWieldedItem(Item item) {
	this.wieldedItem = item;
    }

    public static WieldSpot stringToWieldSpot(String s) {
	for (WieldSpot w : wieldSpots) {
	    if (w.getName().equals(s)) {
		return w;
	    }
	}
	Util.logError("Unknown wield spot");
	return null;
    }

}
