package lists;

import java.util.ArrayList;
import java.util.Iterator;

public class BufferedList<E> implements Iterable<E> {
    
    private ArrayList<E> list;
    private ArrayList<E> addList;
    private ArrayList<E> removeList;
    
    public BufferedList() {
	list = new ArrayList<E>();
	addList = new ArrayList<E>();
	removeList = new ArrayList<E>();
    }
    
    public E get(int i) {
	return list.get(i);
    }
    
    public E getLastAdded() {
	if (addList.size() > 0)
	    return addList.get(addList.size() - 1);
	else if (list.size() > 0)
	    return list.get(list.size() - 1);
	else
	    return null;
    }
    
    public void add(E e) {
	addList.add(e);
    }
    
    public void remove(E e) {
	removeList.add(e);
    }
    
    public void update() {
	for (E e : addList)
	    list.add(e);
	addList.clear();
	for (E e : removeList)
	    list.remove(e);
	removeList.clear();
    }
    
    public ArrayList<E> getList() {
	return list;
    }
    
    public ArrayList<E> getAddBuffer() {
	return addList;
    }
    
    public Iterator<E> iterator() {
	return list.iterator();
    }
    
}
