package lists;

import items.Item;

import java.util.ArrayList;

public class ItemPage {

    private static final String alphabet = "abcdefghijklmnopqrstuvwxyz";

    private ArrayList<ListItem> listItems;
    private int separators = 0;
    private int size;
    private int firstLetterIndex;

    public ItemPage(int size) {
	this.size = size;
	listItems = new ArrayList<ListItem>();
    }

    public void addListItem(ListItem listItem) {
	listItems.add(listItem);
    }

    public void addToBottom(ArrayList<Item> list) {
	ArrayList<ListItem> newList = new ArrayList<ListItem>();
	for (int i = 0; i < list.size(); i++) {
	    newList.add(new ListItem(list.get(i), alphabet.charAt(i)));
	}
	listItems.addAll(0, newList);
    }

    public ArrayList<ListItem> getListItems() {
	return listItems;
    }

    public boolean isFull() {
	return listItems.size() + separators >= size;
    }

    public void addItem(Item item) {
	listItems.add(new ListItem(item, alphabet.charAt(listItems.size()
		+ firstLetterIndex)));
    }

    public void setFirstLetterIndex(int firstLetterIndex) {
	this.firstLetterIndex = firstLetterIndex;
    }

    public void addSeparator() {
	listItems.get(listItems.size() - 1).setSeparatorHere();
	separators++;
    }

    public ArrayList<ListItem> getWieldedItems() {
	ArrayList<ListItem> newList = new ArrayList<ListItem>();

	for (int i = 0; i < firstLetterIndex; i++) {
	    newList.add(listItems.get(i));
	}
	return newList;
    }
}
