package maps;

import java.util.HashMap;

import util.Util;

public class GroundType {
    
    private static HashMap<String, GroundType> types = new HashMap<String, GroundType>();
    
    public static final String FILE_NAME = "groundtypes.dat";
    
    private String name;
    private boolean blocksSight;
    private boolean walkable;
    private boolean rideable;
    private boolean swimmable;
    private boolean levitable;
    
    private GroundType(String[] attributes) {
	name = attributes[0];
	blocksSight = Boolean.parseBoolean(attributes[1]);
	walkable = Boolean.parseBoolean(attributes[2]);
	rideable = Boolean.parseBoolean(attributes[3]);
	swimmable = Boolean.parseBoolean(attributes[4]);
	levitable = Boolean.parseBoolean(attributes[5]);
    }
    
    public static GroundType get(String name) {
	return types.get(name);
    }

    public static void loadTypes() {
	for (String[] attributes : Util.getPrototypeAttributes(FILE_NAME, ";")) {
	    GroundType type = new GroundType(attributes);
	    types.put(type.name, type);
	}
    }
    
    public String getName() {
	return name;
    }
    
    public boolean isBlocksSight() {
	return blocksSight;
    }
    
    public boolean isWalkable() {
	return walkable;
    }
    
    public boolean isRideable() {
	return rideable;
    }
    
    public boolean isSwimmable() {
	return swimmable;
    }
    
    public boolean isLevitable() {
	return levitable;
    }

}
