package maps;

import java.util.HashMap;

import models.GameModel;

public class MapList {

    public static final String VILLAGE_MAP_NAME = "village";
    public static final String TEST_MAP_NAME = "test map";
    public static final String CELLAR_NAME = "cellar";
    public static final String VILLAGE_MAP_FILENAME = "mymap.dat";
    public static final String TEST_MAP_FILENAME = "testmap.dat";
    public static final String CELLAR_FILENAME = "cellar.dat";
    
    private GameModel model;
    private HashMap<String, Map> maps;
    private HashMap<String, String> mapFiles;
    
    public MapList(GameModel m) {
	model = m;
	maps = new HashMap<String, Map>();
	initMapFileNames();
    }
    
    public void put(String name, Map map) {
	maps.put(name, map);
    }
    
    public Map get(String name) {
	if (!maps.containsKey(name)) {
	    initMap(name);
	}
	return maps.get(name);
    }
    
    private void initMap(String name) {
	maps.put(name, new Map(model, name, mapFiles.get(name)));
    }
    
    private void initMapFileNames() {
	mapFiles = new HashMap<String, String>();
	mapFiles.put(VILLAGE_MAP_NAME, VILLAGE_MAP_FILENAME);
	mapFiles.put(TEST_MAP_NAME, TEST_MAP_FILENAME);
	mapFiles.put(CELLAR_NAME, CELLAR_FILENAME);
    }

}
