package models;

import java.text.DecimalFormat;

import lists.ItemList;
import ui.Jorma;
import ui.Window;
import views.InventoryView;
import views.View;
import chars.Player;
import controllers.InventoryController;

public class InventoryModel extends Model {

    public static final int ACTION_USE = 1;
    public static final int ACTION_WIELD = 2;
    public static final int ACTION_DROP = 3;

    public static final DecimalFormat decFormat = new DecimalFormat("#.###");

    private int action = ACTION_USE;
    private ItemList itemList;
    private Player player;

    public InventoryModel(Window window) {
	super(window);
	this.view = new InventoryView(this);
	this.controller = new InventoryController(this);
	itemList = new ItemList(View.HEIGHT - 19);
	player = (Player) ((GameModel) Jorma.MODEL_GAME).getPlayer();
    }

    public Player getPlayer() {
	return player;
    }

    public int getAction() {
	return action;
    }
    
    public void setAction(int action) {
	this.action = action;
    }

    public ItemList getItemList() {
	return itemList;
    }

    public void updateList() {
	itemList.update(player.getItems());
    }
}
