package models;

import java.util.ArrayList;

import lists.JList;
import lists.JListObject;
import skills.Skill;
import ui.Jorma;
import ui.Window;
import views.SkillsView;
import views.View;
import chars.Char;
import controllers.SkillsController;

public class SkillsModel extends Model {
    
    private Char player;
    private JList skillList;
    
    public SkillsModel(Window window) {
	super(window);
	this.view = new SkillsView(this);
	this.controller = new SkillsController(this);
	skillList = new JList(View.HEIGHT - 4);
	player = ((GameModel) Jorma.MODEL_GAME).getPlayer();
    }

    public JList getSkillList() {
	return skillList;
    }

    public Char getPlayer() {
	return player;
    }

    public void updateList(ArrayList<Skill> skills) {
	skillList.clear();
	for (Skill s : skills) {
	    skillList.addObject(new JListObject(s, s.getName()));
	}
    }

}
