package models;

import java.util.ArrayList;

import lists.JList;
import lists.JListObject;
import spells.Spell;
import ui.Jorma;
import ui.Window;
import views.SpellsView;
import views.View;
import chars.Char;
import controllers.SpellsController;

public class SpellsModel extends Model {

    private JList spellList;
    private Char player;

    public SpellsModel(Window window) {
	super(window);
	this.view = new SpellsView(this);
	this.controller = new SpellsController(this);
	spellList = new JList(View.HEIGHT - 4);
	player = ((GameModel) Jorma.MODEL_GAME).getPlayer();
    }

    public JList getSpellList() {
	return spellList;
    }

    public Char getPlayer() {
	return player;
    }

    public void updateList(ArrayList<Spell> spells) {
	spellList.clear();
	for (Spell s : spells) {
	    spellList.addObject(new JListObject(s, s.getName()));
	}
    }
}
