package quests;

import java.util.ArrayList;

import models.GameModel;


public abstract class Quest {

    public static final ArrayList<Quest> QUESTS = new ArrayList<Quest>();		// TODO: why static final?
    
    protected ArrayList<Condition> conditions;
    protected Condition nextCondition;
    protected GameModel gameModel;

    public Quest(GameModel gameModel) {
	this.gameModel = gameModel;
	conditions = new ArrayList<Condition>();
    }

    public Condition getNextCondition() {
	return nextCondition;
    }

    public void updateNextCondition() {
	while (nextCondition != null && nextCondition.check()) {
	    int newIndex = conditions.indexOf(nextCondition) + 1;
	    nextCondition = conditions.size() > newIndex ? conditions
		    .get(newIndex) : null;
	}
    }
    
    public static void updateConditions() {
	for (Quest q : Quest.QUESTS) {
	    q.updateNextCondition();
	}
    }
}