package quests;

import lists.BufferedList;
import models.GameModel;
import chars.Char;
import events.ContactEvent;
import events.Event;

public class RidingQuest extends Quest {

    public RidingQuest(final GameModel gameModel) {
	super(gameModel);

	conditions.add(new Condition() {

	    private BufferedList<Char> chars = gameModel.getCurrentMap().getChars();
	    private Char horse;
	    private Char horsekeeper;

	    public boolean check() {
		for (Char c : chars) {
		    if (c.getName().equals("horse")) {
			horse = c;
		    } else if (c.getName().equals("horsekeeper")) {
			horsekeeper = c;
		    }
		}
		Event e = gameModel.getEvents().getLastAdded();
		if (e.isType(Event.START_RIDING) && horse != null && horsekeeper != null && ((ContactEvent) e).getCharacter().equals(horse)) {
			horsekeeper.setTalk("Getting on with it?");
			return true;
		} else return false;
	    }
	});

	conditions.add(new Condition() {

	    private BufferedList<Char> chars = gameModel.getCurrentMap().getChars();
	    private Char horse;
	    private Char horsekeeper;

	    public boolean check() {

		for (Char c : chars) {
		    if (c.getName().equals("horse")) {
			horse = c;
		    } else if (c.getName().equals("horsekeeper")) {
			horsekeeper = c;
		    }
		}
		Event e = gameModel.getEvents().getLastAdded();
		if (e.isType(Event.STOP_RIDING) && horse != null && horsekeeper != null && ((ContactEvent) e).getCharacter().equals(horse)) {
			horsekeeper.setTalk("So you tried my horse... Fifty bucks n' it's yours.");
			return true;
		} else
		    return false;
	    }
	});

	nextCondition = conditions.get(0);
    }

}
