package quests;

import lists.BufferedList;
import models.GameModel;
import skills.Skill;
import chars.Char;
import events.ContactEvent;
import events.Event;
import events.MiscEvent;
import events.MoveEvent;

public class TestQuest extends Quest {

    public TestQuest(final GameModel gameModel) {
	super(gameModel);
	conditions.add(new Condition() {
	    public boolean check() {
		Event e = gameModel.getEvents().getLastAdded();
		if (e.isType(Event.MOVE) && ((MoveEvent) e).getNewCell().getX() == 4) {
		    gameModel.addEvent(new MiscEvent(0, "Go to x coordinate 7 and drop a weapon", Event.MESSAGE));
		    return true;
		}
		return false;
	    }
	});
	conditions.add(new Condition() {

	    private BufferedList<Char> chars = gameModel.getCurrentMap().getChars();
	    private Char idiot;

	    public boolean check() {
		Event e = gameModel.getEvents().getLastAdded();
		for (Char c : chars) {
		    if (c.getName().equals("idiot"))
			idiot = c;
		}
		if (e.isType(Event.MOVE) && idiot != null && ((MoveEvent) e).getNewCell().getX() == 7) {
		    gameModel.addEvent(new MiscEvent(0, "You completed the test quest. et olekaan", Event.MESSAGE));
		    if (idiot != null) 
			idiot.setTalk("You completed the test quest. nyt olet");
		    return true;
		}
		return false;
	    }
	});
	conditions.add(new Condition() {

	    private BufferedList<Char> chars = gameModel.getCurrentMap().getChars();
	    private Char idiot;

	    public boolean check() {
		Event e = gameModel.getEvents().getLastAdded();
		for (Char c : chars) {
		    if (c.getName().equals("idiot"))
			idiot = c;
		}
		if (e.isType(Event.TALK) && idiot != null && ((ContactEvent) e).getCharacter().equals(idiot)) {
		    idiot.setTalk(null);
		    Skill.SWIMMING.learn();
		    Skill.GHOSTING.learn();
		    gameModel.addEvent(new MiscEvent(0, "Swimming n' ghosting ok.", Event.MESSAGE));
		    idiot.setOrigCell(gameModel.getCurrentMap().getCells()[2][5]);
		    return true;
		}
		return false;
	    }
	});

	nextCondition = conditions.get(0);
    }
}
