package skills;

import java.util.ArrayList;

public class Skill {

    private static final ArrayList<Skill> skills = new ArrayList<Skill>();
    public static final Skill STRENGTH = new Skill("Strength", true);
    public static final Skill AVOIDING = new Skill("Avoiding", true);
    public static final Skill RECOVERY = new Skill("Recovery", true);
    public static final Skill MEDITATING = new Skill("Meditating", false);
    public static final Skill SWIMMING = new Skill("Swimming", false);
    public static final Skill LEVITATING = new Skill("Levitating", false);
    public static final Skill GHOSTING = new Skill("Ghosting", false);
    
    public static final Skill SWORD_MASTERY = new Skill("Sword mastery", false);
    
    public static final int LEVEL_MAX = 100;

    private String name;
    private boolean learned;
    private int level;

    private Skill(String name, boolean learned) {
	this.name = name;
	this.level = 0;
	this.learned = learned;
	skills.add(this);
    }

    public static ArrayList<Skill> getSkills() {
	return skills;
    }
    
    public static ArrayList<Skill> getLearnedSkills() {
	ArrayList<Skill> learnedSkills = new ArrayList<Skill>();
	for (Skill s : skills) {
	    if (s.learned) {
		learnedSkills.add(s);
	    }
	}
	return learnedSkills;
    }

    public void levelUp(int count) {
	this.level += count;
	if (this.level > 100) {
	    this.level = 100;
	}
    }

    public void levelUp() {
	this.levelUp(1);
    }

    public int getLevel() {
	return level;
    }

    public String getName() {
	return name;
    }

    public boolean isLearned() {
	return learned;
    }

    public void setLevel(int level) {
	this.level = level;
    }

    public void learn() {
	this.learned = true;
	this.level = 1;
    }
}
