package spells;

import java.awt.Color;
import java.awt.Graphics2D;

import maps.Cell;
import ui.Jorma;
import views.GameView;
import chars.Char;

public abstract class Bolt extends Spell {

    protected int damage;
    protected Color color;
    
    public Bolt(Char caster, String name, int cost, int damage, Color color, int level) {
	super(caster, name, cost, 1, true, level);
	this.damage = damage;
	this.color = color;
    }

    protected void doStartEffect() {
	Char target = caster.getAdjacentChar(direction);
	
	if (target != null)
	    target.decreaseHp(damage);
    }

    public void draw(Graphics2D g) {
	Cell c = caster.getCell().getAdjacentCell(direction);
	GameView gameView = (GameView) (Jorma.MODEL_GAME.getView());
	
	gameView.clearAt(g, c);
	g.setColor(color);
	gameView.drawCharAt(g, '*', c);
    }

    protected void doEndEffect() { }
}
