package spells;

import java.awt.Graphics2D;

import maps.Cell;
import ui.Jorma;
import util.ColorData;
import views.GameView;
import chars.Char;

public class Invisibility extends Spell {

    public Invisibility(Char caster) {
	super(caster, "Invisibility", 30, 10, false, 10);
    }

    protected void doStartEffect() {
    }

    public void draw(Graphics2D g) {
	Cell c = caster.getCell();
	GameView gameView = (GameView) (Jorma.MODEL_GAME.getView());
	
	gameView.clearAt(g, c);
	g.setColor(ColorData.getColor("grey", 3));
	gameView.drawCharAt(g, '_', c);
    }

    protected void doEndEffect() {
    }

}
