package ui;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JComponent;

import util.Util;

public class Screen extends JComponent {

    private static final long serialVersionUID = 7634808578567113875L;
    private final int fps = 15;
    private final Timer timer;

    private Jorma jorma;
    private Font font;

    public Screen(Jorma jorma) {
	this.jorma = jorma;
	timer = new Timer();
	setSize(800, 600);

	initFont();
	timer.schedule(new PaintTask(), 1000 / fps, 1000 / fps);
    }

    public void paint(Graphics g_) {
	Graphics2D g = (Graphics2D) g_;

	g.setFont(font);
	if (jorma.getCurrentModel() != null) {
	    jorma.getCurrentModel().getView().paint(g);
	}
    }

    private void initFont() {
	try {
	    font = Font.createFont(0,
		    getClass().getResourceAsStream("Fixedsys500c.ttf"))
		    .deriveFont(0, 15.0F);
	} catch (Exception e) {
	    Util.logError("Couldn't load font.");
	}
    }

    public class PaintTask extends TimerTask {

	public void run() {
	    Screen.this.repaint();
	}
    }

}
