package views;

import java.awt.Graphics2D;
import java.util.ArrayList;

import models.HelpModel;

public class HelpView extends View {
    
    public HelpView(HelpModel model) {
	super(model);
    }
    
    public void paint(Graphics2D g) {
	drawBackground(g);
	drawTitle(g, "HELP");
	drawHelp(g);
    }

    private void drawHelp(Graphics2D g) {
	int y = 0;
	int firstLine = ((HelpModel) model).getFirstLine();
	ArrayList<String> lines = ((HelpModel) model).getLines();
	for (int i = firstLine; i < lines.size() && i - firstLine < HelpModel.PAGE_LENGTH; i++) {
	    drawStringAt(g, lines.get(i), 3, 3 + y);
	    y++;
	}

	drawStringAt(g, "Up arrow - Previous page", WIDTH - 24, 4);
	drawStringAt(g, "Down arrow - Next page", WIDTH - 24, 5);
    }
}
