package views;

import java.awt.Graphics2D;

import models.HighscoresModel;
import util.ColorData;
import util.Util;

public class HighscoresView extends View{

    public HighscoresView(HighscoresModel model) {
	super(model);
    }
    
    public void paint(Graphics2D g) {
	drawBackground(g);
	drawTitle(g, "HIGH SCORES");
	drawText(g);
	drawList(g);
    }

    private void drawText(Graphics2D g) {
	g.setColor(ColorData.getColor("grey", 3));
	drawStringAt(
		g,
		Util.splitToLines(
			"Here are the most glorious adventurers. They have suffered and bleeded, they have fought hounourably and survived through numerous dangers. They have been the ones who have had the bravery to bluster Jorma's sovereignty. No pain, no gain, they used to say. Shall their names be forged in this list to reminder all the forthcoming adventurers of their deeds!",
			40), 3, 3);
    }

    private void drawList(Graphics2D g) {
	for (int i = 1; i <= 10; i++) {
	    drawStringAt(g, i + ". -", 6, 15 + i);
	}
    }
}
