package views;

import java.awt.Graphics2D;

import lists.JList;
import lists.JListObject;
import models.SkillsModel;
import skills.Skill;
import chars.Char;

public class SkillsView extends View {

    public SkillsView(SkillsModel model) {
	super(model);
    }

    public void paint(Graphics2D g) {
	drawBackground(g);
	drawTitle(g, "SKILLS");
	drawSkills(g);
    }

    private void drawSkills(Graphics2D g) {
	Char player = ((SkillsModel) model).getPlayer();
	JList skillList = ((SkillsModel) model).getSkillList();

	g.setColor(COLOR_GREY); // TODO: correct colors please
	drawStringAt(g, "You are level " + (int) player.getLevel() + " ukkeli.", 2, 2);

	drawStringAt(g, "Up arrow - Previous skills", WIDTH - 24, 4);
	drawStringAt(g, "Down arrow - Next skills", WIDTH - 24, 5);

	drawStringAt(g, "Skill", 5, 4);
	drawStringAt(g, "Level", 20, 4);
	
	int i = 0;
	for (JListObject o : skillList.getVisibleObjects()) {
	    Skill skill = (Skill) o.getObject();
	    drawStringAt(g, o.getLetter() + ") " + skill.getName(), 5, 6 + i);
	    drawStringAt(g, Integer.toString(skill.getLevel()), 20, 6 + i);
	    i++;
	}
    }

}
