package views;

import java.awt.Graphics2D;

import lists.JList;
import lists.JListObject;
import models.SpellsModel;
import spells.Spell;
import chars.Char;

public class SpellsView extends View {

    public SpellsView(SpellsModel model) {
	super(model);
    }
    
    public void paint(Graphics2D g) {
	drawBackground(g);
	drawTitle(g, "SPELLS");
	drawList(g);
    }

    private void drawList(Graphics2D g) {
	Char player = ((SpellsModel) model).getPlayer();
	JList spellList = ((SpellsModel) model).getSpellList();
	
	g.setColor(COLOR_GREY); // TODO: correct colors please
	drawStringAt(g, "You have " + (int) player.getMp()
		+ " mana points left.", 2, 2);

	drawStringAt(g, "Up arrow - Previous spells", WIDTH - 24, 4);
	drawStringAt(g, "Down arrow - Next spells", WIDTH - 24, 5);

	int i = 0;
	for (JListObject o : spellList.getVisibleObjects()) {
	    Spell spell = (Spell) o.getObject();

	    if (player.getMp() >= spell.getCost()) {
		g.setColor(COLOR_GREY);
	    } else {
		g.setColor(COLOR_DARKER_RED);
	    }
	    drawStringAt(g, o.getLetter() + ") " + spell.getName(), 5, 4 + i);
	    i++;
	}
    }
}
